N	EQU	4		; #define	N	4
P	EQU	6		; #define	P	6

PLACE	1000H			; localiza bloco de dados
seq1:	WORD	10		; int seq [N] = {10, 5, 6, 2};
	WORD	5
	WORD	6
	WORD	2
seq2:	WORD	20		; int seq2 [P] = {20, 7, 5, 
	WORD	7		; 		  10, 4, 8};
	WORD	5
	WORD	10
	WORD	4
	WORD	8

PLACE	0000H			; localiza bloco de cdigo
main:	MOV	SP, 2000H	; inicializa SP
	MOV	R6, seq1	; 1 parmetro
	MOV	R7, N		; 2 parmetro
	CALL	ordenaBolha	; chama a funo
	MOV	R6, seq2	; 1 parmetro
	MOV	R7, P		; 2 parmetro
	CALL	ordenaBolha	; chama a funo
fim:	JMP	fim		; fim do programa

ordenaBolha:		; a vem no R6. n vem no R7

; houveTroca usa o R8
; i usa o R9
; R10  usado para valores temporrios
	PUSH	R8		; guarda o valor de R8
	PUSH	R9		; guarda o valor de R9
	PUSH	R10		; guarda o valor de R10
ronda:	MOV	R8, 0		; houveTroca = false;
	MOV	R9, 0		; i = 0;
iterao:
	MOV	R10, R7	; cpia de n
	SUB	R10, 1	; n-1
	CMP	R9, R10	; i < n-1 ?
	JGE	teste		; se no, o ciclo acabou
	MOV	R10, R9	; obtm cpia de i
	SHL	R10, 1	; 2*i (ender. em bytes)
	ADD	R10, R6	; endereo de a [i] 
	MOV	R1, R10	; 1 parmetro (&a[i])
	MOV	R10, R9	; obtm cpia de i
	ADD	R10, 1	; i+1
	SHL	R10, 1	; 2*(i+1)
	ADD	R10, R6	; endereo de a [i+1] 
	MOV	R2, R10	; 2 parmetro (&a[i+1])
	CALL	ordena	; chama a funo
	OR	R8, R1	; houveTroca || ordena
	ADD	R9, 1		; i = i + 1; 
	JMP	iterao	; prxima iterao
teste:	CMP	R8, 0	; houveTroca = falso ?
	JNZ	ronda		; mais uma ronda
	POP	R10		; repe o valor de R10
	POP	R9		; repe o valor de R9
	POP	R8		; repe o valor de R8
	RET			; retorna da funo

ordena: 			
; x vem em R1, y vem em R2 
; R8 e R9 so usados como registos temporrios
; auxiliar usa o R10
	PUSH	R8		; guarda o valor de R8
	PUSH	R9		; guarda o valor de R9
	MOV	R8, [R1]	; *x
	MOV	R9, [R2]	; *y
	CMP	R8, R9	; (*x > *y) ?
	JLE	else		; se no, executa o else
	PUSH	R10			; guarda o valor de R10
	MOV	R10, R8	; auxiliar = *x;
	MOV	[R1], R9	; *x = *y;
	MOV	[R2], R10	; *y = auxiliar;
	POP	R10			; repe o valor de R10					
	MOV	R1, 1		; true
	JMP	acaba		; return true;
else:	MOV	R1, 0		; false
acaba:	
	POP	R9		; repe o valor de R9
	POP	R8		; repe o valor de R8
	RET			; return false;
; o valor retornado est no R1


